'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var reselect = require('reselect');
var immer = require('immer');
var react = require('react');

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}
});

/* eslint react-hooks/exhaustive-deps: 0 */
immer.enablePatches();
var useIsomorphicLayoutEffect = typeof window !== "undefined" ? react.useLayoutEffect : react.useEffect;
function toAnonFunction(arg) {
  if (typeof arg === "function") return arg;
  return function () {
    return arg;
  };
}

var incrementParam = function incrementParam(num) {
  return ++num;
};

var emptyArray = [];
var Constants = {
  IS_NOT_PRODUCTION: "development" !== "production"
};
var useUpdate = function useUpdate(persistencePlugin) {
  var _useState = react.useState(0),
      setState = _useState[1];

  react.useEffect(function () {
    if (persistencePlugin != null && persistencePlugin.current.isSSR) {
      persistencePlugin.getState();
    }
  }, emptyArray);
  return react.useCallback(function () {
    return setState(incrementParam);
  }, emptyArray);
};
var getPromiseWithCallbacks = function getPromiseWithCallbacks() {
  var resolve = undefined;
  var reject = undefined;
  var promise = new Promise(function (resolvePromise, rejectPromise) {
    resolve = resolvePromise;
    reject = rejectPromise;
  });
  return {
    promise: promise,
    resolve: resolve,
    reject: reject
  };
};
var isClientSide = typeof window !== "undefined";

var connectDevTools = function connectDevTools(name) {
  try {
    if (typeof window !== "undefined" && typeof window.__REDUX_DEVTOOLS_EXTENSION__ !== "undefined") {
      var devTools = window.__REDUX_DEVTOOLS_EXTENSION__.connect({
        name: "Store " + name,
        serialize: true
      });

      return devTools;
    }
  } catch (err) {}

  return undefined;
};

function isPromise(obj) {
  return !!obj && (typeof obj === "object" || typeof obj === "function") && typeof obj.then === "function";
}

var connectPersistenceStorage = function connectPersistenceStorage(_ref) {
  var persistenceName = _ref.persistenceKey,
      produce = _ref.produce,
      _ref$debounceWait = _ref.debounceWait,
      debounceWait = _ref$debounceWait === void 0 ? 3000 : _ref$debounceWait,
      _ref$persistenceMetho = _ref.persistenceMethod,
      persistenceMethod = _ref$persistenceMetho === void 0 ? isClientSide ? window.localStorage : undefined : _ref$persistenceMetho,
      isSSR = _ref.isSSR,
      resolve = _ref.resolve,
      reject = _ref.reject;
  if (!persistenceMethod) return null;
  var isConnected = false;
  var timeout;

  var setStateFn = function setStateFn(state) {
    var possiblePromise = persistenceMethod.setItem(persistenceName, JSON.stringify(state));

    if (isPromise(possiblePromise)) {
      return possiblePromise.then(function () {
        isConnected = true;
      });
    }

    if (!isConnected) isConnected = true;
    return void 0;
  };

  var setState = function setState(state) {
    var execPersistence = function execPersistence() {
      timeout = undefined;
      setStateFn(state);
    };

    if (timeout !== undefined) clearTimeout(timeout);

    if (debounceWait <= 0) {
      execPersistence();
      timeout = undefined;
    } else {
      timeout = setTimeout(execPersistence, debounceWait);
    }
  };

  var getState = function getState() {
    if (isConnected || !persistenceMethod) {
      resolve();
      return void 0;
    }

    try {
      var statePromise = persistenceMethod.getItem(persistenceName);

      if (isPromise(statePromise)) {
        return statePromise.then(function (state) {
          if (state == null) {
            isConnected = true;
            resolve();
            return void 0;
          }

          produce(function () {
            return _extends({}, produce(), JSON.parse(state));
          });
          isConnected = true;
          resolve();
          return void 0;
        })["catch"](reject);
      } else {
        if (statePromise == null) {
          isConnected = true;
          resolve();
          return void 0;
        }

        produce(function () {
          return _extends({}, produce(), JSON.parse(statePromise));
        });
        isConnected = true;
        resolve();
        return void 0;
      }
    } catch (err) {
      reject(err);
      return void 0;
    }
  };

  if (isSSR) {
    resolve();
  } else {
    getState();
  }

  return {
    getState: getState,
    setState: setState,
    current: {
      persistenceKey: persistenceName,
      persistenceMethod: persistenceMethod,
      isSSR: isSSR,
      isConnected: isConnected,
      debounceWait: debounceWait
    }
  };
};

/**
 *  Create **react-state-selector** global store
 */

function createStore(initialStore, options) {
  var _options$storagePersi;

  {
    for (var name in options == null ? void 0 : options.hooks) {
      if (name.length < 4 || name.slice(0, 3) !== "use" || name.charAt(3) === name.charAt(3).toLowerCase()) {
        throw new Error("All hooks should follow the rules of hooks for naming and \"" + name + "\" doesn't");
      }
    }
  }

  {
    if (options != null && options.actions && options.asyncActions) {
      var asyncActionsKeys = Object.keys(options.asyncActions);

      for (var key in options.actions) {
        if (asyncActionsKeys.includes(key)) {
          throw new Error("All the actions and asyncActions should have different names and \"" + key + "\" exists in both objects!");
        }
      }
    }
  }

  var devTools;
  var localStoragePlugin;
  var isReady = Promise.resolve();

  if (options != null && options.devName && (options.devToolsInProduction || Constants.IS_NOT_PRODUCTION)) {
    devTools = connectDevTools(options.devName);
  }

  var listeners = new Map();
  var currentStore = initialStore;

  if (devTools) {
    devTools.init(currentStore);
  }

  var useStore = function useStore() {
    var update = useUpdate(localStoragePlugin);
    useIsomorphicLayoutEffect(function () {
      var globalListener = reselect.createSelector(function (s) {
        return s;
      }, function () {
        update();
      });
      listeners.set(globalListener, null);
      return function () {
        listeners["delete"](globalListener);
      };
    }, emptyArray);
    return currentStore;
  };

  var produceObj = {
    produce: function produce(draft) {
      var _localStoragePlugin;

      if (typeof draft !== "function") return currentStore;

      if (devTools) {
        var produceFn = immer.produceWithPatches(draft);
        var produceResult = produceFn(currentStore);
        currentStore = produceResult[0];
        devTools.send({
          type: "produce",
          payload: produceResult[1]
        }, currentStore);
      } else {
        var _produceFn = immer.produce(draft);

        currentStore = _produceFn(currentStore);
      }

      listeners.forEach(function (props, listener) {
        listener(currentStore, props);
      });
      (_localStoragePlugin = localStoragePlugin) == null ? void 0 : _localStoragePlugin.setState(currentStore);
      return currentStore;
    },
    asyncProduce: function () {
      var _asyncProduce = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(draft) {
        var _localStoragePlugin2;

        var storeDraft;
        return runtime_1.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(typeof draft !== "function")) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return", currentStore);

              case 2:
                storeDraft = immer.createDraft(currentStore);
                _context.next = 5;
                return Promise.resolve(draft(storeDraft));

              case 5:
                immer.finishDraft(storeDraft, function (changes) {
                  if (changes.length) {
                    currentStore = immer.applyPatches(currentStore, changes);

                    if (devTools) {
                      devTools.send({
                        type: "asyncProduce",
                        payload: changes
                      }, currentStore);
                    }

                    listeners.forEach(function (props, listener) {
                      listener(currentStore, props);
                    });
                  }
                });
                (_localStoragePlugin2 = localStoragePlugin) == null ? void 0 : _localStoragePlugin2.setState(currentStore);
                return _context.abrupt("return", currentStore);

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function asyncProduce(_x) {
        return _asyncProduce.apply(this, arguments);
      }

      return asyncProduce;
    }()
  };

  if (options != null && (_options$storagePersi = options.storagePersistence) != null && _options$storagePersi.isActive) {
    var _getPromiseWithCallba = getPromiseWithCallbacks(),
        promise = _getPromiseWithCallba.promise,
        resolve = _getPromiseWithCallba.resolve,
        reject = _getPromiseWithCallba.reject;

    isReady = promise;
    if (typeof initialStore !== "object" || Array.isArray(initialStore)) throw new Error("For local storage persistence your store has to be an object");
    var persistenceKey = options.storagePersistence.persistenceKey || options.devName;
    if (!persistenceKey) throw new Error("You have to specify persistence key or devName");
    localStoragePlugin = connectPersistenceStorage({
      persistenceKey: persistenceKey,
      produce: produceObj.produce,
      debounceWait: options.storagePersistence.debounceWait,
      persistenceMethod: options.storagePersistence.persistenceMethod,
      isSSR: options.storagePersistence.isSSR,
      resolve: resolve,
      reject: reject
    });
  }

  var actionsObj = {};
  var asyncActionsObj = {};

  var _loop = function _loop() {
    var _Object$entries$_i = _Object$entries[_i],
        actionName = _Object$entries$_i[0],
        actionFn = _Object$entries$_i[1];

    actionsObj[actionName] = function () {
      var _localStoragePlugin3;

      var actionDraft = actionFn.apply(void 0, arguments);

      if (devTools) {
        var produceFn = immer.produceWithPatches(actionDraft);
        var produceResult = produceFn(currentStore);
        currentStore = produceResult[0];
        devTools.send({
          type: actionName,
          payload: produceResult[1]
        }, currentStore);
      } else {
        var _produceFn2 = immer.produce(actionDraft);

        currentStore = _produceFn2(currentStore);
      }

      listeners.forEach(function (props, listener) {
        listener(currentStore, props);
      });
      (_localStoragePlugin3 = localStoragePlugin) == null ? void 0 : _localStoragePlugin3.setState(currentStore);
      return currentStore;
    };
  };

  for (var _i = 0, _Object$entries = Object.entries((options == null ? void 0 : options.actions) || {}); _i < _Object$entries.length; _i++) {
    _loop();
  }

  var _loop2 = function _loop2() {
    var _Object$entries2$_i = _Object$entries2[_i2],
        actionName = _Object$entries2$_i[0],
        actionFn = _Object$entries2$_i[1];
    asyncActionsObj[actionName] = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2() {
      var _args2 = arguments;
      return runtime_1.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return actionFn(produceObj.produce).apply(void 0, _args2);

            case 2:
              return _context2.abrupt("return", currentStore);

            case 3:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
  };

  for (var _i2 = 0, _Object$entries2 = Object.entries((options == null ? void 0 : options.asyncActions) || {}); _i2 < _Object$entries2.length; _i2++) {
    _loop2();
  }

  var hooksObj = {};

  var _loop3 = function _loop3() {
    var _Object$entries3$_i = _Object$entries3[_i3],
        hookName = _Object$entries3$_i[0],
        hookSelector = _Object$entries3$_i[1];

    hooksObj[hookName] = function (hooksProps, hookPropsDeps) {
      var update = useUpdate(localStoragePlugin);
      var props = react.useMemo(toAnonFunction(hooksProps), hookPropsDeps || [hooksProps]);
      var firstSelectorCall = react.useRef(true);

      var _useMemo = react.useMemo(function () {
        return {
          updateSelector: reselect.createSelector(hookSelector, function (result) {
            stateRef.current = result;

            if (firstSelectorCall.current) {
              firstSelectorCall.current = false;
            } else {
              update();
            }
          }),
          initialStateRef: hookSelector(currentStore, props)
        };
      }, emptyArray),
          updateSelector = _useMemo.updateSelector,
          initialStateRef = _useMemo.initialStateRef;

      var stateRef = react.useRef(initialStateRef);
      useIsomorphicLayoutEffect(function () {
        updateSelector(currentStore, props);
        listeners.set(updateSelector, props);
      }, [props]);
      react.useEffect(function () {
        return function () {
          listeners["delete"](updateSelector);
        };
      }, emptyArray);
      return stateRef.current;
    };
  };

  for (var _i3 = 0, _Object$entries3 = Object.entries((options == null ? void 0 : options.hooks) || {}); _i3 < _Object$entries3.length; _i3++) {
    _loop3();
  }

  return _extends({
    useStore: useStore,
    actions: actionsObj,
    asyncActions: asyncActionsObj,
    hooks: hooksObj,
    isReady: isReady
  }, produceObj);
}

var defaultIsReady = /*#__PURE__*/Promise.resolve();
/**
 * Create React Context version of a **react-state-selector** global store
 */

function createStoreContext(initialStore, options) {
  {
    for (var name in options == null ? void 0 : options.hooks) {
      if (name.length < 4 || name.slice(0, 3) !== "use" || name.charAt(3) === name.charAt(3).toLowerCase()) {
        throw new Error("All hooks should follow the rules of hooks for naming and \"" + name + "\" doesn't");
      }
    }

    if (options != null && options.actions && options.asyncActions) {
      var asyncActionsKeys = Object.keys(options.asyncActions);

      for (var key in options.actions) {
        if (asyncActionsKeys.includes(key)) {
          throw new Error("All the actions and asyncActions should have different names and \"" + key + "\" exists in both objects!");
        }
      }
    }
  }

  var createStoragePersistenceInstance = function createStoragePersistenceInstance(produceStore, debugName) {
    var _options$storagePersi;

    if (options != null && (_options$storagePersi = options.storagePersistence) != null && _options$storagePersi.isActive) {
      if (typeof initialStore !== "object" || Array.isArray(initialStore)) throw new Error("For local storage persistence your store has to be an object");

      var _getPromiseWithCallba = getPromiseWithCallbacks(),
          isReady = _getPromiseWithCallba.promise,
          resolve = _getPromiseWithCallba.resolve,
          reject = _getPromiseWithCallba.reject;

      var persistenceKey;

      if (options.storagePersistence.persistenceKey) {
        persistenceKey = options.storagePersistence.persistenceKey;
      } else if (options.devName) {
        persistenceKey = options.devName;
      }

      if (!persistenceKey) throw new Error("You have to specify persistence key or devName");

      if (debugName) {
        persistenceKey += "-" + debugName;
      } else if (debugName === null) {
        persistenceKey += "-noProvider";
      }

      return Object.assign(connectPersistenceStorage({
        persistenceKey: persistenceKey,
        produce: produceStore,
        debounceWait: options.storagePersistence.debounceWait,
        persistenceMethod: options.storagePersistence.persistenceMethod,
        isSSR: options.storagePersistence.isSSR,
        resolve: resolve,
        reject: reject
      }), {
        isReady: isReady
      });
    }

    return null;
  };

  var createDevToolsInstance = function createDevToolsInstance(debugName) {
    if (options != null && options.devName && (options.devToolsInProduction || Constants.IS_NOT_PRODUCTION)) {
      var devToolsName;

      if (debugName) {
        devToolsName = options.devName + "-" + debugName;
      } else if (debugName === null) {
        devToolsName = options.devName + "-noProvider";
      } else {
        devToolsName = options.devName;
      }

      var devTools = connectDevTools(devToolsName);

      if (devTools) {
        devTools.init(initialStore);
      }

      return devTools;
    }

    return undefined;
  };

  var createProduceObj = function createProduceObj(storeRef) {
    return {
      produce: function produce(draft) {
        var _storeRef$storagePers;

        if (typeof draft !== "function") return storeRef.store;

        if (storeRef.devTools) {
          var produceFn = immer.produceWithPatches(draft);
          var produceResult = produceFn(storeRef.store);
          storeRef.store = produceResult[0];
          storeRef.devTools.send({
            type: "produce",
            payload: produceResult[1]
          }, storeRef.store);
        } else {
          var _produceFn = immer.produce(draft);

          storeRef.store = _produceFn(storeRef.store);
        }

        storeRef.listeners.forEach(function (props, listener) {
          listener(storeRef.store, props);
        });
        (_storeRef$storagePers = storeRef.storagePersistence) == null ? void 0 : _storeRef$storagePers.setState(storeRef.store);
        return storeRef.store;
      },
      asyncProduce: function () {
        var _asyncProduce = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(draft) {
          var _storeRef$storagePers2;

          var storeDraft;
          return runtime_1.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  if (!(typeof draft !== "function")) {
                    _context.next = 2;
                    break;
                  }

                  return _context.abrupt("return", storeRef.store);

                case 2:
                  storeDraft = immer.createDraft(storeRef.store);
                  _context.next = 5;
                  return Promise.resolve(draft(storeDraft));

                case 5:
                  immer.finishDraft(storeDraft, function (changes) {
                    if (changes.length) {
                      storeRef.store = immer.applyPatches(storeRef.store, changes);

                      if (storeRef.devTools) {
                        storeRef.devTools.send({
                          type: "asyncProduce",
                          payload: changes
                        }, storeRef.store);
                      }

                      storeRef.listeners.forEach(function (props, listener) {
                        listener(storeRef.store, props);
                      });
                    }
                  });
                  (_storeRef$storagePers2 = storeRef.storagePersistence) == null ? void 0 : _storeRef$storagePers2.setState(storeRef.store);
                  return _context.abrupt("return", storeRef.store);

                case 8:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function asyncProduce(_x) {
          return _asyncProduce.apply(this, arguments);
        }

        return asyncProduce;
      }()
    };
  };

  var providerRefCallback = function providerRefCallback(debugName) {
    return function () {
      var storeRef = {
        store: initialStore,
        listeners: new Map(),
        devTools: createDevToolsInstance(debugName)
      };
      var isReady = defaultIsReady;
      var produceObj = createProduceObj(storeRef);
      storeRef.produce = produceObj;
      var persistance = createStoragePersistenceInstance(produceObj.produce, debugName);

      if (persistance) {
        var current = persistance.current,
            getState = persistance.getState,
            setState = persistance.setState;
        storeRef.storagePersistence = {
          current: current,
          getState: getState,
          setState: setState
        };
        isReady = persistance.isReady;
      }

      return Object.assign(storeRef, {
        produce: produceObj,
        isReady: isReady
      });
    };
  };

  var StoreContext = react.createContext({
    current: providerRefCallback(null)()
  });
  var Provider = react.memo(function (_ref) {
    var children = _ref.children,
        debugName = _ref.debugName;
    var initialRef = react.useMemo(providerRefCallback(debugName), emptyArray);
    var value = react.useRef(initialRef);
    return react.createElement(StoreContext.Provider, {
      value: value,
      children: children
    });
  });

  var useStore = function useStore() {
    var storeCtx = react.useContext(StoreContext);
    var update = useUpdate(storeCtx.current.storagePersistence);
    useIsomorphicLayoutEffect(function () {
      var globalListener = reselect.createSelector(function (s) {
        return s;
      }, function () {
        update();
      });
      storeCtx.current.listeners.set(globalListener, null);
      return function () {
        storeCtx.current.listeners["delete"](globalListener);
      };
    }, emptyArray);
    return storeCtx.current.store;
  };

  var useProduce = function useProduce() {
    var storeCtx = react.useContext(StoreContext);
    return storeCtx.current.produce;
  };

  var useActions = function useActions() {
    var storeCtx = react.useContext(StoreContext);
    var produceObj = useProduce();
    return react.useMemo(function () {
      if (storeCtx.current.actions === undefined) {
        var actionsObj = {};

        var _loop = function _loop() {
          var _Object$entries$_i = _Object$entries[_i],
              actionName = _Object$entries$_i[0],
              actionFn = _Object$entries$_i[1];

          actionsObj[actionName] = function () {
            var _storeCtx$current$sto;

            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            var actionDraft = actionFn.apply(void 0, args.concat([produceObj.produce]));

            if (storeCtx.current.devTools) {
              var produceFn = immer.produceWithPatches(actionDraft);
              var produceResult = produceFn(storeCtx.current.store);
              storeCtx.current.store = produceResult[0];
              storeCtx.current.devTools.send({
                type: actionName,
                payload: produceResult[1]
              }, storeCtx.current.store);
            } else {
              var _produceFn2 = immer.produce(actionDraft);

              storeCtx.current.store = _produceFn2(storeCtx.current.store);
            }

            storeCtx.current.listeners.forEach(function (props, listener) {
              listener(storeCtx.current.store, props);
            });
            (_storeCtx$current$sto = storeCtx.current.storagePersistence) == null ? void 0 : _storeCtx$current$sto.setState(storeCtx.current.store);
            return storeCtx.current.store;
          };
        };

        for (var _i = 0, _Object$entries = Object.entries((options == null ? void 0 : options.actions) || {}); _i < _Object$entries.length; _i++) {
          _loop();
        }

        storeCtx.current.actions = actionsObj;
      }

      return storeCtx.current.actions;
    }, emptyArray);
  };

  var useAsyncActions = function useAsyncActions() {
    var storeCtx = react.useContext(StoreContext);
    var produceObj = useProduce();
    return react.useMemo(function () {
      if (storeCtx.current.asyncActions === undefined) {
        var asyncActionsObj = {};

        var _loop2 = function _loop2() {
          var _Object$entries2$_i = _Object$entries2[_i2],
              actionName = _Object$entries2$_i[0],
              actionFn = _Object$entries2$_i[1];
          asyncActionsObj[actionName] = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2() {
            var _args2 = arguments;
            return runtime_1.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    _context2.next = 2;
                    return actionFn(produceObj.produce).apply(void 0, _args2);

                  case 2:
                    return _context2.abrupt("return", storeCtx.current.store);

                  case 3:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2);
          }));
        };

        for (var _i2 = 0, _Object$entries2 = Object.entries(options && options.asyncActions || {}); _i2 < _Object$entries2.length; _i2++) {
          _loop2();
        }

        storeCtx.current.asyncActions = asyncActionsObj;
      }

      return storeCtx.current.asyncActions;
    }, emptyArray);
  };

  var hooksObj = {};

  var _loop3 = function _loop3() {
    var _Object$entries3$_i = _Object$entries3[_i3],
        hookName = _Object$entries3$_i[0],
        hookSelector = _Object$entries3$_i[1];

    hooksObj[hookName] = function (hooksProps, hookPropsDeps) {
      var storeCtx = react.useContext(StoreContext);
      var update = useUpdate(storeCtx.current.storagePersistence);
      var props = react.useMemo(toAnonFunction(hooksProps), hookPropsDeps || [hooksProps]);
      var firstSelectorCall = react.useRef(true);

      var _useMemo = react.useMemo(function () {
        return {
          updateSelector: reselect.createSelector(hookSelector, function (result) {
            stateRef.current = result;

            if (firstSelectorCall.current) {
              firstSelectorCall.current = false;
            } else {
              update();
            }
          }),
          initialStateRef: hookSelector(storeCtx.current.store, props)
        };
      }, emptyArray),
          updateSelector = _useMemo.updateSelector,
          initialStateRef = _useMemo.initialStateRef;

      var stateRef = react.useRef(initialStateRef);
      useIsomorphicLayoutEffect(function () {
        updateSelector(storeCtx.current.store, props);
        storeCtx.current.listeners.set(updateSelector, props);
      }, [props]);
      react.useEffect(function () {
        return function () {
          storeCtx.current.listeners["delete"](updateSelector);
        };
      }, emptyArray);
      return stateRef.current;
    };
  };

  for (var _i3 = 0, _Object$entries3 = Object.entries((options == null ? void 0 : options.hooks) || {}); _i3 < _Object$entries3.length; _i3++) {
    _loop3();
  }

  var useIsReady = function useIsReady() {
    var _useContext = react.useContext(StoreContext),
        isReady = _useContext.current.isReady;

    var _useState = react.useState(isReady === defaultIsReady),
        ready = _useState[0],
        setReady = _useState[1];

    react.useEffect(function () {
      if (isReady !== defaultIsReady) {
        isReady.then(function () {
          setTimeout(function () {
            setReady(true);
          }, 0);
        });
      }
    }, [setReady]);
    return ready;
  };

  return {
    Provider: Provider,
    useStore: useStore,
    useProduce: useProduce,
    useActions: useActions,
    useAsyncActions: useAsyncActions,
    hooks: hooksObj,
    useIsReady: useIsReady
  };
}

Object.keys(immer).forEach(function (k) {
  if (k !== 'default') Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () {
      return immer[k];
    }
  });
});
Object.defineProperty(exports, 'createSelector', {
  enumerable: true,
  get: function () {
    return reselect.createSelector;
  }
});
exports.createStore = createStore;
exports.createStoreContext = createStoreContext;
//# sourceMappingURL=react-state-selector.cjs.development.js.map
